//+------------------------------------------------------------------+
//|                                               prev_calc_Test.mq5 |
//|                                            2013, MetaDriver Lab |
//|                       https://login.mql5.com/ru/users/MetaDriver |
//+------------------------------------------------------------------+
#property copyright " 2013, MetaDriver Lab"
#property link      "https://login.mql5.com/ru/users/MetaDriver"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_plots   2
#property indicator_label1  "HighBid"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrDarkBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
#property indicator_label2  "LowAsk"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- input parameters
input bool     EveryTick=true; //    ?

//          " "
#define Empty(code)  code             // 1
//#define Empty(code)                  // 2


Empty(
struct MyRates : public MqlRates
  {
   static double     _point; 
   double LoAsk() {return(low+Spread());}
   double Spread() {return(spread*_point);}
  };
static double MyRates::_point=_Point; 

double         HiBidBuffer[];
double         LoAskBuffer[];
MyRates        RatesBuffer[];
) // Empty

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
Empty(
   SetIndexBuffer(0,HiBidBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,LoAskBuffer,INDICATOR_DATA);
   ArraySetAsSeries(RatesBuffer,false);
) // Empty
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   if(!EveryTick && (prev_calculated==rates_total)) return(rates_total);
Empty(
   ArrayResize(RatesBuffer,0);
   int Start=prev_calculated>0?prev_calculated-1:0;
   int Copied=CopyRates(Symbol(),0,0,rates_total-Start,RatesBuffer);
   for(int i=Start;i<rates_total;i++)
     {
      HiBidBuffer[i]=RatesBuffer[i-Start].high;
      LoAskBuffer[i]=RatesBuffer[i-Start].LoAsk();
     }
) // Empty
   Print("prev_calculated == ",prev_calculated,
         ";  rates_total == ",rates_total,
         ";  ArrSize(close) == ",ArraySize(close),
         ";  Copied == ",Copied);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
